Index: cards/CMS_PhaseII/trackMomentumResolution_vs_p_PIX4022.tcl
===================================================================
--- cards/CMS_PhaseII/trackMomentumResolution_vs_p_PIX4022.tcl	(revision 207686c646619354fe7dafb0b6c63415a51cfeb0)
+++ cards/CMS_PhaseII/trackMomentumResolution_vs_p_PIX4022.tcl	(revision 207686c646619354fe7dafb0b6c63415a51cfeb0)
@@ -0,0 +1,86 @@
+#
+# Automatically generated tracker resolution formula for layout: constP
+#
+#  By StefanoMersi on: 2016-08-04.14:46:54
+#
+set ResolutionFormula {    (abs(eta) >= 0.0000 && abs(eta) < 0.2000) * (energy >= 0.0000 && energy < 1.0000) * (0.00458781) + \
+   (abs(eta) >= 0.0000 && abs(eta) < 0.2000) * (energy >= 1.0000 && energy < 10.0000) * (0.004588 + (energy-1.000000)* 0.000044) + \
+   (abs(eta) >= 0.0000 && abs(eta) < 0.2000) * (energy >= 10.0000 && energy < 100.0000) * (0.004981 + (energy-10.000000)* 0.000049) + \
+   (abs(eta) >= 0.0000 && abs(eta) < 0.2000) * (energy >= 100.0000) * (0.009368*energy/100.000000) + \
+   (abs(eta) >= 0.2000 && abs(eta) < 0.4000) * (energy >= 0.0000 && energy < 1.0000) * (0.00502525) + \
+   (abs(eta) >= 0.2000 && abs(eta) < 0.4000) * (energy >= 1.0000 && energy < 10.0000) * (0.005025 + (energy-1.000000)* 0.000037) + \
+   (abs(eta) >= 0.2000 && abs(eta) < 0.4000) * (energy >= 10.0000 && energy < 100.0000) * (0.005358 + (energy-10.000000)* 0.000044) + \
+   (abs(eta) >= 0.2000 && abs(eta) < 0.4000) * (energy >= 100.0000) * (0.009310*energy/100.000000) + \
+   (abs(eta) >= 0.4000 && abs(eta) < 0.6000) * (energy >= 0.0000 && energy < 1.0000) * (0.00498622) + \
+   (abs(eta) >= 0.4000 && abs(eta) < 0.6000) * (energy >= 1.0000 && energy < 10.0000) * (0.004986 + (energy-1.000000)* 0.000038) + \
+   (abs(eta) >= 0.4000 && abs(eta) < 0.6000) * (energy >= 10.0000 && energy < 100.0000) * (0.005327 + (energy-10.000000)* 0.000042) + \
+   (abs(eta) >= 0.4000 && abs(eta) < 0.6000) * (energy >= 100.0000) * (0.009146*energy/100.000000) + \
+   (abs(eta) >= 0.6000 && abs(eta) < 0.8000) * (energy >= 0.0000 && energy < 1.0000) * (0.00544545) + \
+   (abs(eta) >= 0.6000 && abs(eta) < 0.8000) * (energy >= 1.0000 && energy < 10.0000) * (0.005445 + (energy-1.000000)* 0.000037) + \
+   (abs(eta) >= 0.6000 && abs(eta) < 0.8000) * (energy >= 10.0000 && energy < 100.0000) * (0.005783 + (energy-10.000000)* 0.000038) + \
+   (abs(eta) >= 0.6000 && abs(eta) < 0.8000) * (energy >= 100.0000) * (0.009184*energy/100.000000) + \
+   (abs(eta) >= 0.8000 && abs(eta) < 1.0000) * (energy >= 0.0000 && energy < 1.0000) * (0.00664755) + \
+   (abs(eta) >= 0.8000 && abs(eta) < 1.0000) * (energy >= 1.0000 && energy < 10.0000) * (0.006648 + (energy-1.000000)* 0.000037) + \
+   (abs(eta) >= 0.8000 && abs(eta) < 1.0000) * (energy >= 10.0000 && energy < 100.0000) * (0.006977 + (energy-10.000000)* 0.000037) + \
+   (abs(eta) >= 0.8000 && abs(eta) < 1.0000) * (energy >= 100.0000) * (0.010306*energy/100.000000) + \
+   (abs(eta) >= 1.0000 && abs(eta) < 1.2000) * (energy >= 0.0000 && energy < 1.0000) * (0.00976928) + \
+   (abs(eta) >= 1.0000 && abs(eta) < 1.2000) * (energy >= 1.0000 && energy < 10.0000) * (0.009769 + (energy-1.000000)* 0.000030) + \
+   (abs(eta) >= 1.0000 && abs(eta) < 1.2000) * (energy >= 10.0000 && energy < 100.0000) * (0.010037 + (energy-10.000000)* 0.000043) + \
+   (abs(eta) >= 1.0000 && abs(eta) < 1.2000) * (energy >= 100.0000) * (0.013887*energy/100.000000) + \
+   (abs(eta) >= 1.2000 && abs(eta) < 1.4000) * (energy >= 0.0000 && energy < 1.0000) * (0.01391322) + \
+   (abs(eta) >= 1.2000 && abs(eta) < 1.4000) * (energy >= 1.0000 && energy < 10.0000) * (0.013913 + (energy-1.000000)* -0.000054) + \
+   (abs(eta) >= 1.2000 && abs(eta) < 1.4000) * (energy >= 10.0000 && energy < 100.0000) * (0.013423 + (energy-10.000000)* 0.000030) + \
+   (abs(eta) >= 1.2000 && abs(eta) < 1.4000) * (energy >= 100.0000) * (0.016160*energy/100.000000) + \
+   (abs(eta) >= 1.4000 && abs(eta) < 1.6000) * (energy >= 0.0000 && energy < 1.0000) * (0.01661255) + \
+   (abs(eta) >= 1.4000 && abs(eta) < 1.6000) * (energy >= 1.0000 && energy < 10.0000) * (0.016613 + (energy-1.000000)* -0.000140) + \
+   (abs(eta) >= 1.4000 && abs(eta) < 1.6000) * (energy >= 10.0000 && energy < 100.0000) * (0.015351 + (energy-10.000000)* 0.000023) + \
+   (abs(eta) >= 1.4000 && abs(eta) < 1.6000) * (energy >= 100.0000) * (0.017406*energy/100.000000) + \
+   (abs(eta) >= 1.6000 && abs(eta) < 1.8000) * (energy >= 0.0000 && energy < 1.0000) * (0.01756773) + \
+   (abs(eta) >= 1.6000 && abs(eta) < 1.8000) * (energy >= 1.0000 && energy < 10.0000) * (0.017568 + (energy-1.000000)* -0.000166) + \
+   (abs(eta) >= 1.6000 && abs(eta) < 1.8000) * (energy >= 10.0000 && energy < 100.0000) * (0.016071 + (energy-10.000000)* 0.000021) + \
+   (abs(eta) >= 1.6000 && abs(eta) < 1.8000) * (energy >= 100.0000) * (0.017925*energy/100.000000) + \
+   (abs(eta) >= 1.8000 && abs(eta) < 2.0000) * (energy >= 0.0000 && energy < 1.0000) * (0.01826889) + \
+   (abs(eta) >= 1.8000 && abs(eta) < 2.0000) * (energy >= 1.0000 && energy < 10.0000) * (0.018269 + (energy-1.000000)* -0.000292) + \
+   (abs(eta) >= 1.8000 && abs(eta) < 2.0000) * (energy >= 10.0000 && energy < 100.0000) * (0.015645 + (energy-10.000000)* 0.000037) + \
+   (abs(eta) >= 1.8000 && abs(eta) < 2.0000) * (energy >= 100.0000) * (0.019004*energy/100.000000) + \
+   (abs(eta) >= 2.0000 && abs(eta) < 2.2000) * (energy >= 0.0000 && energy < 1.0000) * (0.02128193) + \
+   (abs(eta) >= 2.0000 && abs(eta) < 2.2000) * (energy >= 1.0000 && energy < 10.0000) * (0.021282 + (energy-1.000000)* -0.000536) + \
+   (abs(eta) >= 2.0000 && abs(eta) < 2.2000) * (energy >= 10.0000 && energy < 100.0000) * (0.016454 + (energy-10.000000)* 0.000046) + \
+   (abs(eta) >= 2.0000 && abs(eta) < 2.2000) * (energy >= 100.0000) * (0.020598*energy/100.000000) + \
+   (abs(eta) >= 2.2000 && abs(eta) < 2.4000) * (energy >= 0.0000 && energy < 1.0000) * (0.02435234) + \
+   (abs(eta) >= 2.2000 && abs(eta) < 2.4000) * (energy >= 1.0000 && energy < 10.0000) * (0.024352 + (energy-1.000000)* -0.000890) + \
+   (abs(eta) >= 2.2000 && abs(eta) < 2.4000) * (energy >= 10.0000 && energy < 100.0000) * (0.016346 + (energy-10.000000)* 0.000036) + \
+   (abs(eta) >= 2.2000 && abs(eta) < 2.4000) * (energy >= 100.0000) * (0.019563*energy/100.000000) + \
+   (abs(eta) >= 2.4000 && abs(eta) < 2.6000) * (energy >= 0.0000 && energy < 1.0000) * (0.02635201) + \
+   (abs(eta) >= 2.4000 && abs(eta) < 2.6000) * (energy >= 1.0000 && energy < 10.0000) * (0.026352 + (energy-1.000000)* -0.000835) + \
+   (abs(eta) >= 2.4000 && abs(eta) < 2.6000) * (energy >= 10.0000 && energy < 100.0000) * (0.018839 + (energy-10.000000)* 0.000023) + \
+   (abs(eta) >= 2.4000 && abs(eta) < 2.6000) * (energy >= 100.0000) * (0.020920*energy/100.000000) + \
+   (abs(eta) >= 2.6000 && abs(eta) < 2.8000) * (energy >= 0.0000 && energy < 1.0000) * (0.03696155) + \
+   (abs(eta) >= 2.6000 && abs(eta) < 2.8000) * (energy >= 1.0000 && energy < 10.0000) * (0.036962 + (energy-1.000000)* -0.001758) + \
+   (abs(eta) >= 2.6000 && abs(eta) < 2.8000) * (energy >= 10.0000 && energy < 100.0000) * (0.021137 + (energy-10.000000)* 0.000024) + \
+   (abs(eta) >= 2.6000 && abs(eta) < 2.8000) * (energy >= 100.0000) * (0.023254*energy/100.000000) + \
+   (abs(eta) >= 2.8000 && abs(eta) < 3.0000) * (energy >= 0.0000 && energy < 1.0000) * (0.04054340) + \
+   (abs(eta) >= 2.8000 && abs(eta) < 3.0000) * (energy >= 1.0000 && energy < 10.0000) * (0.040543 + (energy-1.000000)* -0.001842) + \
+   (abs(eta) >= 2.8000 && abs(eta) < 3.0000) * (energy >= 10.0000 && energy < 100.0000) * (0.023965 + (energy-10.000000)* 0.000028) + \
+   (abs(eta) >= 2.8000 && abs(eta) < 3.0000) * (energy >= 100.0000) * (0.026492*energy/100.000000) + \
+   (abs(eta) >= 3.0000 && abs(eta) < 3.2000) * (energy >= 0.0000 && energy < 1.0000) * (0.04582369) + \
+   (abs(eta) >= 3.0000 && abs(eta) < 3.2000) * (energy >= 1.0000 && energy < 10.0000) * (0.045824 + (energy-1.000000)* -0.002427) + \
+   (abs(eta) >= 3.0000 && abs(eta) < 3.2000) * (energy >= 10.0000 && energy < 100.0000) * (0.023983 + (energy-10.000000)* 0.000022) + \
+   (abs(eta) >= 3.0000 && abs(eta) < 3.2000) * (energy >= 100.0000) * (0.025995*energy/100.000000) + \
+   (abs(eta) >= 3.2000 && abs(eta) < 3.4000) * (energy >= 0.0000 && energy < 1.0000) * (0.05649409) + \
+   (abs(eta) >= 3.2000 && abs(eta) < 3.4000) * (energy >= 1.0000 && energy < 10.0000) * (0.056494 + (energy-1.000000)* -0.003134) + \
+   (abs(eta) >= 3.2000 && abs(eta) < 3.4000) * (energy >= 10.0000 && energy < 100.0000) * (0.028286 + (energy-10.000000)* 0.000031) + \
+   (abs(eta) >= 3.2000 && abs(eta) < 3.4000) * (energy >= 100.0000) * (0.031052*energy/100.000000) + \
+   (abs(eta) >= 3.4000 && abs(eta) < 3.6000) * (energy >= 0.0000 && energy < 1.0000) * (0.07960355) + \
+   (abs(eta) >= 3.4000 && abs(eta) < 3.6000) * (energy >= 1.0000 && energy < 10.0000) * (0.079604 + (energy-1.000000)* -0.004686) + \
+   (abs(eta) >= 3.4000 && abs(eta) < 3.6000) * (energy >= 10.0000 && energy < 100.0000) * (0.037433 + (energy-10.000000)* 0.000046) + \
+   (abs(eta) >= 3.4000 && abs(eta) < 3.6000) * (energy >= 100.0000) * (0.041606*energy/100.000000) + \
+   (abs(eta) >= 3.6000 && abs(eta) < 3.8000) * (energy >= 0.0000 && energy < 1.0000) * (0.10970998) + \
+   (abs(eta) >= 3.6000 && abs(eta) < 3.8000) * (energy >= 1.0000 && energy < 10.0000) * (0.109710 + (energy-1.000000)* -0.006946) + \
+   (abs(eta) >= 3.6000 && abs(eta) < 3.8000) * (energy >= 10.0000 && energy < 100.0000) * (0.047195 + (energy-10.000000)* 0.000064) + \
+   (abs(eta) >= 3.6000 && abs(eta) < 3.8000) * (energy >= 100.0000) * (0.052991*energy/100.000000) + \
+   (abs(eta) >= 3.8000 && abs(eta) < 4.0000) * (energy >= 0.0000 && energy < 1.0000) * (0.13579235) + \
+   (abs(eta) >= 3.8000 && abs(eta) < 4.0000) * (energy >= 1.0000 && energy < 10.0000) * (0.135792 + (energy-1.000000)* -0.008362) + \
+   (abs(eta) >= 3.8000 && abs(eta) < 4.0000) * (energy >= 10.0000 && energy < 100.0000) * (0.060538 + (energy-10.000000)* 0.000094) + \
+   (abs(eta) >= 3.8000 && abs(eta) < 4.0000) * (energy >= 100.0000) * (0.069033*energy/100.000000)
+}