Index: Makefile
===================================================================
--- Makefile	(revision b4786d3e836198e304f8c5ea39d38c79b10ac5b5)
+++ Makefile	(revision 302624fca6ca1247dbb8697c4f2e8ecc730d20b1)
@@ -232,9 +232,15 @@
 	classes/DelphesClasses.h \
 	classes/DelphesFactory.h \
-	classes/DelphesHepMC3Reader.h \
 	modules/Delphes.h \
 	external/ExRootAnalysis/ExRootProgressBar.h \
 	external/ExRootAnalysis/ExRootTreeBranch.h \
-	external/ExRootAnalysis/ExRootTreeWriter.h
+	external/ExRootAnalysis/ExRootTreeWriter.h \
+	external/HepMC3/ReaderAscii.h \
+	external/HepMC3/GenEvent.h \
+	external/HepMC3/GenCrossSection.h \
+	external/HepMC3/GenPdfInfo.h \
+	external/HepMC3/GenParticle.h \
+	external/HepMC3/GenVertex.h \
+	external/HepMC3/Units.h
 DelphesLHEF$(ExeSuf): \
 	tmp/readers/DelphesLHEF.$(ObjSuf)
@@ -672,4 +678,57 @@
 tmp/external/Hector/H_VerticalQuadrupole.$(ObjSuf): \
 	external/Hector/H_VerticalQuadrupole.$(SrcSuf)
+tmp/external/HepMC3/GenCrossSection.$(ObjSuf): \
+	external/HepMC3/GenCrossSection.$(SrcSuf) \
+	external/HepMC3/GenCrossSection.h \
+	external/HepMC3/GenEvent.h
+tmp/external/HepMC3/GenEvent.$(ObjSuf): \
+	external/HepMC3/GenEvent.$(SrcSuf) \
+	external/HepMC3/GenEvent.h \
+	external/HepMC3/GenParticle.h \
+	external/HepMC3/GenVertex.h \
+	external/HepMC3/Data/GenEventData.h
+tmp/external/HepMC3/GenHeavyIon.$(ObjSuf): \
+	external/HepMC3/GenHeavyIon.$(SrcSuf) \
+	external/HepMC3/GenHeavyIon.h
+tmp/external/HepMC3/GenParticle.$(ObjSuf): \
+	external/HepMC3/GenParticle.$(SrcSuf) \
+	external/HepMC3/GenParticle.h \
+	external/HepMC3/GenVertex.h \
+	external/HepMC3/GenEvent.h \
+	external/HepMC3/Setup.h \
+	external/HepMC3/Attribute.h
+tmp/external/HepMC3/GenPdfInfo.$(ObjSuf): \
+	external/HepMC3/GenPdfInfo.$(SrcSuf) \
+	external/HepMC3/GenPdfInfo.h
+tmp/external/HepMC3/GenRunInfo.$(ObjSuf): \
+	external/HepMC3/GenRunInfo.$(SrcSuf) \
+	external/HepMC3/GenRunInfo.h \
+	external/HepMC3/Data/GenRunInfoData.h
+tmp/external/HepMC3/GenVertex.$(ObjSuf): \
+	external/HepMC3/GenVertex.$(SrcSuf) \
+	external/HepMC3/GenVertex.h \
+	external/HepMC3/GenParticle.h \
+	external/HepMC3/GenEvent.h \
+	external/HepMC3/Setup.h \
+	external/HepMC3/Attribute.h
+tmp/external/HepMC3/ReaderAscii.$(ObjSuf): \
+	external/HepMC3/ReaderAscii.$(SrcSuf) \
+	external/HepMC3/ReaderAscii.h \
+	external/HepMC3/GenEvent.h \
+	external/HepMC3/GenParticle.h \
+	external/HepMC3/GenVertex.h \
+	external/HepMC3/Units.h
+tmp/external/HepMC3/ReaderAsciiHepMC2.$(ObjSuf): \
+	external/HepMC3/ReaderAsciiHepMC2.$(SrcSuf) \
+	external/HepMC3/ReaderAsciiHepMC2.h \
+	external/HepMC3/GenEvent.h \
+	external/HepMC3/GenVertex.h \
+	external/HepMC3/GenParticle.h \
+	external/HepMC3/GenHeavyIon.h \
+	external/HepMC3/GenPdfInfo.h \
+	external/HepMC3/Setup.h
+tmp/external/HepMC3/Setup.$(ObjSuf): \
+	external/HepMC3/Setup.$(SrcSuf) \
+	external/HepMC3/Setup.h
 tmp/external/TrackCovariance/AcceptanceClx.$(ObjSuf): \
 	external/TrackCovariance/AcceptanceClx.$(SrcSuf)
@@ -1213,4 +1272,14 @@
 	tmp/external/Hector/H_VerticalKicker.$(ObjSuf) \
 	tmp/external/Hector/H_VerticalQuadrupole.$(ObjSuf) \
+	tmp/external/HepMC3/GenCrossSection.$(ObjSuf) \
+	tmp/external/HepMC3/GenEvent.$(ObjSuf) \
+	tmp/external/HepMC3/GenHeavyIon.$(ObjSuf) \
+	tmp/external/HepMC3/GenParticle.$(ObjSuf) \
+	tmp/external/HepMC3/GenPdfInfo.$(ObjSuf) \
+	tmp/external/HepMC3/GenRunInfo.$(ObjSuf) \
+	tmp/external/HepMC3/GenVertex.$(ObjSuf) \
+	tmp/external/HepMC3/ReaderAscii.$(ObjSuf) \
+	tmp/external/HepMC3/ReaderAsciiHepMC2.$(ObjSuf) \
+	tmp/external/HepMC3/Setup.$(ObjSuf) \
 	tmp/external/TrackCovariance/AcceptanceClx.$(ObjSuf) \
 	tmp/external/TrackCovariance/ObsTrk.$(ObjSuf) \
@@ -1906,4 +1975,10 @@
 	@touch $@
 
+external/HepMC3/Units.h: \
+	external/HepMC3/Errors.h \
+	external/HepMC3/Setup.h \
+	external/HepMC3/FourVector.h
+	@touch $@
+
 external/fastjet/ClusterSequence.hh: \
 	external/fastjet/PseudoJet.hh \
@@ -1990,9 +2065,9 @@
 	@touch $@
 
+modules/EnergyScale.h: \
+	classes/DelphesModule.h
+	@touch $@
+
 modules/Isolation.h: \
-	classes/DelphesModule.h
-	@touch $@
-
-modules/EnergyScale.h: \
 	classes/DelphesModule.h
 	@touch $@
@@ -2041,4 +2116,9 @@
 modules/TrackPileUpSubtractor.h: \
 	classes/DelphesModule.h
+	@touch $@
+
+external/HepMC3/ReaderAscii.h: \
+	external/HepMC3/Reader.h \
+	external/HepMC3/GenEvent.h
 	@touch $@
 
@@ -2099,6 +2179,16 @@
 	@touch $@
 
+external/HepMC3/Data/GenEventData.h: \
+	external/HepMC3/Data/GenParticleData.h \
+	external/HepMC3/Data/GenVertexData.h \
+	external/HepMC3/Units.h
+	@touch $@
+
 modules/PileUpMerger.h: \
 	classes/DelphesModule.h
+	@touch $@
+
+external/HepMC3/GenPdfInfo.h: \
+	external/HepMC3/Attribute.h
 	@touch $@
 
@@ -2132,4 +2222,9 @@
 modules/Cloner.h: \
 	classes/DelphesModule.h
+	@touch $@
+
+external/HepMC3/ReaderAsciiHepMC2.h: \
+	external/HepMC3/Reader.h \
+	external/HepMC3/GenEvent.h
 	@touch $@
 
@@ -2191,4 +2286,9 @@
 	@touch $@
 
+external/HepMC3/Attribute.h: \
+	external/HepMC3/GenParticle_fwd.h \
+	external/HepMC3/GenVertex_fwd.h
+	@touch $@
+
 modules/VertexSorter.h: \
 	classes/DelphesModule.h
@@ -2230,4 +2330,9 @@
 	@touch $@
 
+external/HepMC3/GenRunInfo.h: \
+	external/HepMC3/Units.h \
+	external/HepMC3/Attribute.h
+	@touch $@
+
 modules/PdgCodeFilter.h: \
 	classes/DelphesModule.h
@@ -2240,4 +2345,21 @@
 classes/DelphesSTDHEPReader.h: \
 	classes/DelphesXDRReader.h
+	@touch $@
+
+external/HepMC3/GenEvent.h: \
+	external/HepMC3/Units.h \
+	external/HepMC3/GenParticle_fwd.h \
+	external/HepMC3/GenVertex_fwd.h \
+	external/HepMC3/GenPdfInfo_fwd.h \
+	external/HepMC3/GenHeavyIon_fwd.h \
+	external/HepMC3/GenCrossSection_fwd.h \
+	external/HepMC3/GenHeavyIon.h \
+	external/HepMC3/GenPdfInfo.h \
+	external/HepMC3/GenCrossSection.h \
+	external/HepMC3/GenRunInfo.h
+	@touch $@
+
+external/HepMC3/GenHeavyIon.h: \
+	external/HepMC3/Attribute.h
 	@touch $@
 
@@ -2310,4 +2432,12 @@
 	@touch $@
 
+external/HepMC3/GenVertex.h: \
+	external/HepMC3/GenParticle_fwd.h \
+	external/HepMC3/GenVertex_fwd.h \
+	external/HepMC3/Data/GenVertexData.h \
+	external/HepMC3/FourVector.h \
+	external/HepMC3/GenEvent.h
+	@touch $@
+
 modules/ClusterCounting.h: \
 	classes/DelphesModule.h
@@ -2321,4 +2451,8 @@
 	external/fastjet/JetDefinition.hh \
 	external/fastjet/PseudoJet.hh
+	@touch $@
+
+external/HepMC3/GenCrossSection.h: \
+	external/HepMC3/Attribute.h
 	@touch $@
 
@@ -2373,4 +2507,12 @@
 modules/StatusPidFilter.h: \
 	classes/DelphesModule.h
+	@touch $@
+
+external/HepMC3/GenParticle.h: \
+	external/HepMC3/Data/GenParticleData.h \
+	external/HepMC3/FourVector.h \
+	external/HepMC3/GenParticle_fwd.h \
+	external/HepMC3/GenVertex_fwd.h \
+	external/HepMC3/GenEvent.h
 	@touch $@
 