Index: cards/CMS_PhaseII_0PU.tcl
===================================================================
--- cards/CMS_PhaseII_0PU.tcl	(revision a0236d54d16d0a116b68ed17322989e6a6458853)
+++ cards/CMS_PhaseII_0PU.tcl	(revision 576428a68a0ef8ecd0e9a171809c953aba0980c7)
@@ -32,14 +32,14 @@
   EFlowMerger
 
+  PhotonIsolation
   PhotonEfficiency
-  PhotonIsolation
-
-  ElectronFilter
+  
+  ElectronFilter 
+  ElectronIsolation
   ElectronEfficiency
-  ElectronIsolation
-
+ 
+  MuonIsolation
   MuonEfficiency
-  MuonIsolation
-
+  
   NeutrinoFilter
 
@@ -670,4 +670,30 @@
 }
 
+####################
+# Photon isolation #
+####################
+
+module Isolation PhotonIsolation {
+  
+  # particle for which calculate the isolation
+  set CandidateInputArray ECal/eflowPhotons
+  
+  # isolation collection
+  set IsolationInputArray EFlowMerger/eflow
+ 
+  # output array
+  set OutputArray photons
+  
+  # isolation cone
+  set DeltaRMax 0.3
+  
+  # minimum pT  
+  set PTMin     1.0
+  
+  # iso ratio to cut
+  set PTRatioMax 9999.
+}
+
+
 
 #####################
@@ -678,5 +704,5 @@
   
   ## input particles
-  set InputArray ECal/eflowPhotons
+  set InputArray PhotonIsolation/photons 
   ## output particles
   set OutputArray photons
@@ -690,28 +716,24 @@
 }
 
-####################
-# Photon isolation #
-####################
-
-module Isolation PhotonIsolation {
-  
-  # particle for which calculate the isolation
-  set CandidateInputArray PhotonEfficiency/photons 
+
+######################
+# Electron isolation #
+######################
+
+module Isolation ElectronIsolation {
+  
+  set CandidateInputArray ElectronFilter/electrons
   
   # isolation collection
   set IsolationInputArray EFlowMerger/eflow
- 
-  # output array
-  set OutputArray photons
-  
-  # isolation cone
+  
+  set OutputArray electrons
+  
   set DeltaRMax 0.3
-  
-  # minimum pT  
-  set PTMin     1.0
-  
-  # iso ratio to cut
+  set PTMin 1.0
   set PTRatioMax 9999.
-}
+
+}
+
 
 
@@ -722,5 +744,5 @@
 module Efficiency ElectronEfficiency {
   
-  set InputArray ElectronFilter/electrons
+  set InputArray ElectronIsolation/electrons
   set OutputArray electrons
   
@@ -760,16 +782,15 @@
 }
 
-######################
-# Electron isolation #
-######################
-
-module Isolation ElectronIsolation {
-  
-  set CandidateInputArray ElectronEfficiency/electrons
-  
+##################
+# Muon isolation #
+##################
+
+module Isolation MuonIsolation {
+  set CandidateInputArray MuonMomentumSmearing/muons
+ 
   # isolation collection
   set IsolationInputArray EFlowMerger/eflow
-  
-  set OutputArray electrons
+ 
+  set OutputArray muons
   
   set DeltaRMax 0.3
@@ -780,5 +801,4 @@
 
 
-
 ###################
 # Muon efficiency #
@@ -787,5 +807,5 @@
 module Efficiency MuonEfficiency {
   
-  set InputArray MuonMomentumSmearing/muons
+  set InputArray MuonIsolation/muons
  
   set OutputArray muons
@@ -805,22 +825,4 @@
 
 
-
-##################
-# Muon isolation #
-##################
-
-module Isolation MuonIsolation {
-  set CandidateInputArray MuonEfficiency/muons
- 
-  # isolation collection
-  set IsolationInputArray EFlowMerger/eflow
- 
-  set OutputArray muons
-  
-  set DeltaRMax 0.3
-  set PTMin 1.0
-  set PTRatioMax 9999.
-
-}
 
 
Index: cards/CMS_PhaseII_200PU.tcl
===================================================================
--- cards/CMS_PhaseII_200PU.tcl	(revision a0236d54d16d0a116b68ed17322989e6a6458853)
+++ cards/CMS_PhaseII_200PU.tcl	(revision 576428a68a0ef8ecd0e9a171809c953aba0980c7)
@@ -42,13 +42,13 @@
   RunPUPPI
 
+  PhotonIsolation
   PhotonEfficiency
-  PhotonIsolation
-
+  
+  ElectronIsolation
   ElectronEfficiency
-  ElectronIsolation
-
+ 
+  MuonIsolation
   MuonEfficiency
-  MuonIsolation
-
+  
   NeutrinoFilter
 
@@ -804,4 +804,31 @@
 
 
+####################
+# Photon isolation #
+####################
+
+module Isolation PhotonIsolation {
+  
+  # particle for which calculate the isolation
+  set CandidateInputArray ECal/eflowPhotons
+  
+  # isolation collection
+  set IsolationInputArray EFlowMerger/eflow
+ 
+  # output array
+  set OutputArray photons
+  
+  # isolation cone
+  set DeltaRMax 0.3
+  
+  # minimum pT  
+  set PTMin     1.0
+  
+  # iso ratio to cut
+  set PTRatioMax 9999.
+}
+
+
+
 #####################
 # Photon efficiency #
@@ -811,5 +838,5 @@
   
   ## input particles
-  set InputArray ECal/eflowPhotons
+  set InputArray PhotonIsolation/photons 
   ## output particles
   set OutputArray photons
@@ -823,28 +850,24 @@
 }
 
-####################
-# Photon isolation #
-####################
-
-module Isolation PhotonIsolation {
-  
-  # particle for which calculate the isolation
-  set CandidateInputArray PhotonEfficiency/photons 
+
+######################
+# Electron isolation #
+######################
+
+module Isolation ElectronIsolation {
+  
+  set CandidateInputArray ElectronFilter/electrons
   
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
- 
-  # output array
-  set OutputArray photons
-  
-  # isolation cone
+  set IsolationInputArray EFlowMerger/eflow
+  
+  set OutputArray electrons
+  
   set DeltaRMax 0.3
-  
-  # minimum pT  
-  set PTMin     1.0
-  
-  # iso ratio to cut
+  set PTMin 1.0
   set PTRatioMax 9999.
-}
+
+}
+
 
 
@@ -855,5 +878,5 @@
 module Efficiency ElectronEfficiency {
   
-  set InputArray ElectronFilter/electrons
+  set InputArray ElectronIsolation/electrons
   set OutputArray electrons
   
@@ -893,16 +916,15 @@
 }
 
-######################
-# Electron isolation #
-######################
-
-module Isolation ElectronIsolation {
-  
-  set CandidateInputArray ElectronEfficiency/electrons
-  
+##################
+# Muon isolation #
+##################
+
+module Isolation MuonIsolation {
+  set CandidateInputArray MuonMomentumSmearing/muons
+ 
   # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
-  
-  set OutputArray electrons
+  set IsolationInputArray EFlowMerger/eflow
+ 
+  set OutputArray muons
   
   set DeltaRMax 0.3
@@ -913,5 +935,4 @@
 
 
-
 ###################
 # Muon efficiency #
@@ -920,5 +941,5 @@
 module Efficiency MuonEfficiency {
   
-  set InputArray MuonMomentumSmearing/muons
+  set InputArray MuonIsolation/muons
  
   set OutputArray muons
@@ -937,23 +958,4 @@
 }
 
-
-
-##################
-# Muon isolation #
-##################
-
-module Isolation MuonIsolation {
-  set CandidateInputArray MuonEfficiency/muons
- 
-  # isolation collection
-  set IsolationInputArray RunPUPPI/PuppiParticles
- 
-  set OutputArray muons
-  
-  set DeltaRMax 0.3
-  set PTMin 1.0
-  set PTRatioMax 9999.
-
-}
 
 