Index: external/fastjet/internal/ClosestPair2D.hh
===================================================================
--- external/fastjet/internal/ClosestPair2D.hh	(revision 973b92a3bf3d2d9073e3b7917710e4fac19714c7)
+++ external/fastjet/internal/ClosestPair2D.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: ClosestPair2D.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: ClosestPair2D.hh 4059 2016-03-03 20:49:48Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -38,4 +38,5 @@
 #include "fastjet/internal/SearchTree.hh"
 #include "fastjet/internal/MinHeap.hh"
+#include "fastjet/SharedPtr.hh"
 
 FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
@@ -134,6 +135,6 @@
 
 
-  triplet<std::auto_ptr<Tree> >  _trees;
-  std::auto_ptr<MinHeap> _heap;
+  triplet<SharedPtr<Tree> >  _trees;
+  SharedPtr<MinHeap>     _heap;
   std::vector<Point>     _points;
   std::stack<Point *>    _available_points;
Index: external/fastjet/internal/ClosestPair2DBase.hh
===================================================================
--- external/fastjet/internal/ClosestPair2DBase.hh	(revision 973b92a3bf3d2d9073e3b7917710e4fac19714c7)
+++ external/fastjet/internal/ClosestPair2DBase.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: ClosestPair2DBase.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: ClosestPair2DBase.hh 4049 2016-03-03 13:45:47Z salam $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -48,5 +48,5 @@
   double x, y;
 
-  Coord2D() {};
+  Coord2D() : x(0.0), y(0.0) {};
 
   Coord2D(double a, double b): x(a), y(b) {};
Index: external/fastjet/internal/DnnPlane.hh
===================================================================
--- external/fastjet/internal/DnnPlane.hh	(revision 973b92a3bf3d2d9073e3b7917710e4fac19714c7)
+++ external/fastjet/internal/DnnPlane.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: DnnPlane.hh 3918 2015-07-03 14:19:13Z salam $
+// $Id: DnnPlane.hh 3917 2015-07-03 14:07:50Z salam $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
Index: external/fastjet/internal/LazyTiling9Alt.hh
===================================================================
--- external/fastjet/internal/LazyTiling9Alt.hh	(revision 973b92a3bf3d2d9073e3b7917710e4fac19714c7)
+++ external/fastjet/internal/LazyTiling9Alt.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -3,5 +3,5 @@
 
 //FJSTARTHEADER
-// $Id: LazyTiling9Alt.hh 3808 2015-02-20 11:24:53Z soyez $
+// $Id: LazyTiling9Alt.hh 3807 2015-02-20 11:16:55Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
Index: external/fastjet/internal/TilingExtent.hh
===================================================================
--- external/fastjet/internal/TilingExtent.hh	(revision 973b92a3bf3d2d9073e3b7917710e4fac19714c7)
+++ external/fastjet/internal/TilingExtent.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -5,5 +5,5 @@
 
 //FJSTARTHEADER
-// $Id: TilingExtent.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: TilingExtent.hh 4034 2016-03-02 00:20:27Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -46,4 +46,7 @@
   TilingExtent(ClusterSequence & cs);
 
+  /// constructor that takes a list of PseudoJets
+  TilingExtent(const std::vector<PseudoJet> &particles);
+
   /// returns the suggested minimum rapidity for the tiling
   double minrap() const {return _minrap;}
Index: external/fastjet/internal/base.hh
===================================================================
--- external/fastjet/internal/base.hh	(revision 973b92a3bf3d2d9073e3b7917710e4fac19714c7)
+++ external/fastjet/internal/base.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -1,5 +1,5 @@
 
 //FJSTARTHEADER
-// $Id: base.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: base.hh 4047 2016-03-03 13:21:49Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -33,4 +33,6 @@
 #define __FASTJET_FASTJET_BASE_HH__
 
+#include "fastjet/config.h"
+
 /// \namespace fastjet
 /// the FastJet namespace
@@ -43,3 +45,11 @@
 #define FASTJET_END_NAMESPACE   }
 
+// define a macro to mark virtual function in derived classes as
+// overriding the base-class definition
+#ifdef FASTJET_HAVE_OVERRIDE
+#define FASTJET_OVERRIDE  override
+#else
+#define FASTJET_OVERRIDE  
+#endif
+
 #endif // __FASTJET_FASTJET_BASE_HH__
Index: external/fastjet/internal/deprecated.hh
===================================================================
--- external/fastjet/internal/deprecated.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
+++ external/fastjet/internal/deprecated.hh	(revision 947209d6f2ada7e1660112d9cc726620301106a4)
@@ -0,0 +1,50 @@
+
+//FJSTARTHEADER
+// $Id: deprecated.hh 4098 2016-03-15 16:38:22Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+#ifndef __FASTJET_FASTJET_DEPRECATED_HH__
+#define __FASTJET_FASTJET_DEPRECATED_HH__
+
+#include "fastjet/config.h"
+
+// define a deprecation macro based on the capabilities of the compiler
+// (as determined at configure time).
+#if defined(FASTJET_HAVE_CXX14_DEPRECATED)
+#define FASTJET_DEPRECATED               [[deprecated]]
+#define FASTJET_DEPRECATED_MSG(message)  [[deprecated(message)]]
+#elif defined(FASTJET_HAVE_GNUCXX_DEPRECATED)
+#define FASTJET_DEPRECATED               __attribute__((__deprecated__))
+#define FASTJET_DEPRECATED_MSG(message)  __attribute__((__deprecated__))
+#else
+#define FASTJET_DEPRECATED               
+#define FASTJET_DEPRECATED_MSG(message) 
+#endif
+
+#endif // __FASTJET_FASTJET_DEPRECATED_HH__