Index: cards/delphes_card_CLICdet.tcl
===================================================================
--- cards/delphes_card_CLICdet.tcl	(revision 5a69ba1d7f9c9370e8591cf14ac0e86524760d47)
+++ cards/delphes_card_CLICdet.tcl	(revision 3037765a86d8c1ac3f1ff1d380336a2055477030)
@@ -83,5 +83,4 @@
 
     JetFlavorAssociation
-
     BTagging
     
@@ -123,12 +122,14 @@
     set InputArray ParticlePropagator/chargedHadrons
     set OutputArray chargedHadrons
-
-    # FIXME currently uses tracking efficiency from muon simulation
+    # Current full simulation with CLICdet provides for pions:
+
     set EfficiencyFormula {
- 	(abs(eta) > 2.66)                                               * (0.000) +
-	(abs(eta) < 2.66 && abs(eta) > 2.44) * (pt > 0.1)               * (0.997) + 
-	(abs(eta) < 2.44 && abs(eta) > 2.25) * (pt > 0.1 && pt < 0.174) * (0.997) +
-	(abs(eta) < 2.44 && abs(eta) > 2.25) * (pt > 0.174)             * (1.000) +
-	(abs(eta) < 2.25)                    * (pt > 0.1)               * (1.000)                     }
+(abs(eta) > 2.54) * (0.000) +
+(energy >= 100) * (abs(eta) < 2.54)  * (1.000) +
+(energy < 100 && energy >= 10) * (abs(eta) <=2.54 && abs(eta) > 2.34)  * (0.994) +
+(energy < 100 && energy >= 10) * (abs(eta) <= 2.34) * (1.000) +
+(energy < 10  && energy >= 1) * (abs(eta) <= 2.54 && abs(eta) > 0.55 ) * (0.000) +
+(energy < 10  && energy >= 1) * (abs(eta) <= 0.55 ) * (1.000) 
+    }
 }
 
@@ -141,11 +142,17 @@
     set OutputArray electrons
 
-    # FIXME currently uses tracking efficiency from muon simulation
+
+    # Current full simulation with CLICdet provides for electrons:
     set EfficiencyFormula {
-	(abs(eta) > 2.66)                                               * (0.000) +
-	(abs(eta) < 2.66 && abs(eta) > 2.44) * (pt > 0.1)               * (0.997) + 
-	(abs(eta) < 2.44 && abs(eta) > 2.25) * (pt > 0.1 && pt < 0.174) * (0.997) +
-	(abs(eta) < 2.44 && abs(eta) > 2.25) * (pt > 0.174)             * (1.000) +
-	(abs(eta) < 2.25)                    * (pt > 0.1)               * (1.000)
+		(pt <= 1)                                                               * (0.000) +
+		(abs(eta) > 2.54)                                                       * (0.000) +
+		(energy > 100)                 * (abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (0.993) +
+		(energy > 100)                 * (abs(eta) <= 2.44 && abs(eta) > 2.34 ) * (0.997) +
+		(energy > 100)                 * (abs(eta) <= 2.34  )                   * (1.000) +
+		(energy <= 100 && energy > 10) * (abs(eta) <= 2.54 && abs(eta) > 2.17 ) * (0.998) +
+		(energy <= 100 && energy > 10) * (abs(eta) <= 2.17)                     * (1.000) +
+		(energy <= 10 && energy > 1)   * (abs(eta) > 2.34 )                     * (0.000) +
+		(energy <= 10 && energy > 1)   * (abs(eta) <= 2.34 && abs(eta) > 0.76 ) * (0.997) +
+		(energy <= 10 && energy > 1)   * (abs(eta) <= 0.76)                     * (0.999)
      }
 }
@@ -161,10 +168,13 @@
     # Current full simulation with CLICdet provides for muons:
     set EfficiencyFormula {
-	(abs(eta) > 2.66)                                               * (0.000) +
-	(abs(eta) < 2.66 && abs(eta) > 2.44) * (pt > 0.1)               * (0.997) + 
-	(abs(eta) < 2.44 && abs(eta) > 2.25) * (pt > 0.1 && pt < 0.174) * (0.997) +
-	(abs(eta) < 2.44 && abs(eta) > 2.25) * (pt > 0.174)             * (1.000) +
-	(abs(eta) < 2.25)                    * (pt > 0.1)               * (1.000)
-     }
+	(pt < 1) * (0.000)+
+	(abs(eta) > 2.54) * (0.0000) +
+	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 100)                * (0.994) +
+	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 10 && energy < 100) * (0.997) +
+	(abs(eta) <= 2.54 && abs(eta) > 2.44 ) * (energy >= 1  && energy < 10)  * (0.996) +
+	(abs(eta) <= 2.44 )                    * (energy >= 10)                 * (1.000) +
+	(abs(eta) <= 2.44 && abs(eta) > 2.25 ) * (energy >= 1 && energy < 10)   * (0.999) +
+	(abs(eta) <= 2.25 )                    * (energy >= 1)                  * (1.000) 
+    }
 }
 
@@ -177,13 +187,13 @@
     set OutputArray chargedHadrons
 
-    # Using eta mid-points between evaluated resolutions from full simulation
+
     # Resolution given in dpT/pT.
-    # FIXME: currently uses momentum resolution from single muon simulation!
     set ResolutionFormula {
-	                   (abs(eta) <= 0.26) * (pt > 0.1) * sqrt(0.0162^2 + pt^2*5.863e-4^2) +
-	(abs(eta) > 0.26 && abs(eta) <= 0.45) * (pt > 0.1) * sqrt(0.0065^2 + pt^2*5.949e-5^2) +
-	(abs(eta) > 0.45 && abs(eta) <= 0.65) * (pt > 0.1) * sqrt(0.0041^2 + pt^2*3.014e-5^2) +
-	(abs(eta) > 0.65 && abs(eta) <= 2.75) * (pt > 0.1) * sqrt(0.0036^2 + pt^2*2.977e-5^2) +
-	(abs(eta) > 2.75)                     * (pt > 0.1) * sqrt(0.0021^2 + pt^2*2.189e-5^2)
+	(abs(eta) < 2.66 && abs(eta) >= 2.03 ) * sqrt( 8.56036e-05^2 * pt^2 +0.0148987^2    ) +
+	(abs(eta) < 2.03 && abs(eta) >= 1.01 ) * sqrt( 1.12382e-05^2 * pt^2 +0.00391722^2   ) +
+	(abs(eta) < 1.01 && abs(eta) >= 0.55 ) * sqrt( 1.16768e-05^2 * pt^2 +0.00255204^2    ) +
+	(abs(eta) < 0.55 && abs(eta) >= 0.18 ) * sqrt( 1.28327e-05^2 * pt^2 +0.00220587^2   ) +
+	(abs(eta) < 0.18)                      * sqrt( 1.32845e-05^2 * pt^2 +0.00209325^2   )
+	
     }
 }
@@ -197,13 +207,12 @@
     set OutputArray electrons
 
-    # Using eta mid-points between evaluated resolutions from full simulation
     # Resolution given in dpT/pT.
-    # FIXME: currently uses momentum resolution from single muon simulation!
     set ResolutionFormula {
-	                   (abs(eta) <= 0.26) * (pt > 0.1) * sqrt(0.0162^2 + pt^2*5.863e-4^2) +
-	(abs(eta) > 0.26 && abs(eta) <= 0.45) * (pt > 0.1) * sqrt(0.0065^2 + pt^2*5.949e-5^2) +
-	(abs(eta) > 0.45 && abs(eta) <= 0.65) * (pt > 0.1) * sqrt(0.0041^2 + pt^2*3.014e-5^2) +
-	(abs(eta) > 0.65 && abs(eta) <= 2.75) * (pt > 0.1) * sqrt(0.0036^2 + pt^2*2.977e-5^2) +
-	(abs(eta) > 2.75)                     * (pt > 0.1) * sqrt(0.0021^2 + pt^2*2.189e-5^2)
+	(abs(eta) < 2.66 && abs(eta) >= 2.03 ) * sqrt( 8.62283e-05^2 * pt^2  + 0.0177556^2   ) +
+	(abs(eta) < 2.03 && abs(eta) >= 1.01 ) * sqrt( 1.0915e-05 ^2 * pt^2  + 0.00663766^2  ) +
+	(abs(eta) < 1.01 && abs(eta) >= 0.55 ) * sqrt( 1.15518e-05^2 * pt^2  + 0.00398644^2  ) +
+	(abs(eta) < 0.55 && abs(eta) >= 0.18 ) * sqrt( 1.3307e-05 ^2 * pt^2  + 0.00317807^2  ) +
+	(abs(eta) < 0.18)                      * sqrt( 1.40722e-05^2 * pt^2  + 0.00292138^2  )
+
     }
 }
@@ -217,12 +226,13 @@
     set OutputArray muons
 
-    # Using eta mid-points between evaluated resolutions from full simulation
     # Resolution given in dpT/pT.
     set ResolutionFormula {
-	                   (abs(eta) <= 0.26) * (pt > 0.1) * sqrt(0.0162^2 + pt^2*5.863e-4^2) +
-	(abs(eta) > 0.26 && abs(eta) <= 0.45) * (pt > 0.1) * sqrt(0.0065^2 + pt^2*5.949e-5^2) +
-	(abs(eta) > 0.45 && abs(eta) <= 0.65) * (pt > 0.1) * sqrt(0.0041^2 + pt^2*3.014e-5^2) +
-	(abs(eta) > 0.65 && abs(eta) <= 2.75) * (pt > 0.1) * sqrt(0.0036^2 + pt^2*2.977e-5^2) +
-	(abs(eta) > 2.75)                     * (pt > 0.1) * sqrt(0.0021^2 + pt^2*2.189e-5^2)
+
+	(abs(eta) < 2.66 && abs(eta) >= 2.03 ) * sqrt(4.57439e-05^2 * pt^2*   + 0.0149328^2	   ) +
+	(abs(eta) < 2.03 && abs(eta) >= 1.01 ) * sqrt(9.81626e-06^2 * pt^2*   + 0.00379895^2  ) +
+	(abs(eta) < 1.01 && abs(eta) >= 0.55 ) * sqrt(1.1959e-05^2 * pt^2*   +  0.00242417^2 ) +
+	(abs(eta) < 0.55 && abs(eta) >= 0.18 ) * sqrt(1.20149e-05^2 * pt^2  + 0.00219291^2  ) +
+	(abs(eta) < 0.18)                      * sqrt(1.29686e-05^2 * pt^2  + 0.0020392^2      ) 
+
     }
 }
@@ -1058,5 +1068,5 @@
     # gluon's PDG code has the lowest priority
 
-    # based on arXiv:1211.4462
+    # based on arXiv:1211.4462 (CMS)
     
     # default efficiency formula (misidentification rate)