Index: modules/TrackSmearing.cc
===================================================================
--- modules/TrackSmearing.cc	(revision 641cb3d11465c54796b1c7728ffedad55f2a79fc)
+++ modules/TrackSmearing.cc	(revision 5658083b2ca17c7982a14446c948b512b30f1608)
@@ -3,7 +3,5 @@
  *  Performs d0, dZ, p, Theta, Phi smearing of tracks.
  *
- *
- *
- *  \author A. Hart, M. Selvaggi
+ *  \authors A. Hart, M. Selvaggi
  *
 */
Index: modules/VertexFinder.cc
===================================================================
--- modules/VertexFinder.cc	(revision 641cb3d11465c54796b1c7728ffedad55f2a79fc)
+++ modules/VertexFinder.cc	(revision 5658083b2ca17c7982a14446c948b512b30f1608)
@@ -3,5 +3,5 @@
  *  Cluster vertices from tracks
  *
- *  \author M. Selvaggi - UCL, Louvain-la-Neuve
+ *  \authors A. Hart, M. Selvaggi
  *
  */
@@ -32,9 +32,9 @@
 #include "TVector3.h"
 
-static const double mm  = 1.;
-static const double m = 1000.*mm;
-static const double ns  = 1.;
-static const double s = 1.e+9 *ns;
-static const double c_light   = 2.99792458e+8 * m/s;
+static const Double_t mm  = 1.;
+static const Double_t m = 1000.*mm;
+static const Double_t ns  = 1.;
+static const Double_t s = 1.e+9 *ns;
+static const Double_t c_light   = 2.99792458e+8 * m/s;
 
 //------------------------------------------------------------------------------
@@ -78,10 +78,10 @@
 //------------------------------------------------------------------------------
 //
-bool VertexFinder::secondAscending (pair<unsigned, double> pair0, pair<unsigned, double> pair1)
+Bool_t VertexFinder::secondAscending (pair<UInt_t, Double_t> pair0, pair<UInt_t, Double_t> pair1)
 {
   return (pair0.second < pair1.second);
 }
 
-bool VertexFinder::secondDescending (pair<unsigned, double> pair0, pair<unsigned, double> pair1)
+Bool_t VertexFinder::secondDescending (pair<UInt_t, Double_t> pair0, pair<UInt_t, Double_t> pair1)
 {
   return (pair0.second > pair1.second);
@@ -116,5 +116,5 @@
 ////////////////////////////////////////////////////////////////////////////////
   sort (clusterSumPT2.begin (), clusterSumPT2.end (), secondDescending);
-  for (vector<pair<unsigned, double> >::const_iterator cluster = clusterSumPT2.begin (); cluster != clusterSumPT2.end (); cluster++)
+  for (vector<pair<UInt_t, Double_t> >::const_iterator cluster = clusterSumPT2.begin (); cluster != clusterSumPT2.end (); cluster++)
     {
       // Skip the cluster if it no longer has any tracks
@@ -129,9 +129,9 @@
       // otherwise, mark the seed track as claimed
       
-      if ((int) clusterIDToInt.at (cluster->first).at ("ndf") < fMinNDF)
-        {
-          for (map<unsigned, map<string, int> >::iterator track = trackIDToInt.begin (); track != trackIDToInt.end (); track++)
+      if ((Int_t) clusterIDToInt.at (cluster->first).at ("ndf") < fMinNDF)
+        {
+          for (map<UInt_t, map<string, Int_t> >::iterator track = trackIDToInt.begin (); track != trackIDToInt.end (); track++)
             {
-              if (track->second.at ("clusterIndex") != (int) cluster->first)
+              if (track->second.at ("clusterIndex") != (Int_t) cluster->first)
                 continue;
               track->second["clusterIndex"] = -1;
@@ -162,5 +162,5 @@
 ////////////////////////////////////////////////////////////////////////////////
   clusterSumPT2.clear ();
-  for (map<unsigned, map<string, int> >::const_iterator cluster = clusterIDToInt.begin (); cluster != clusterIDToInt.end (); cluster++)
+  for (map<UInt_t, map<string, Int_t> >::const_iterator cluster = clusterIDToInt.begin (); cluster != clusterIDToInt.end (); cluster++)
   {
     
@@ -171,5 +171,5 @@
   sort (clusterSumPT2.begin (), clusterSumPT2.end (), secondDescending);
   
-  for (vector<pair<unsigned, double> >::const_iterator cluster = clusterSumPT2.begin (); cluster != clusterSumPT2.end (); cluster++)
+  for (vector<pair<UInt_t, Double_t> >::const_iterator cluster = clusterSumPT2.begin (); cluster != clusterSumPT2.end (); cluster++)
   {
     DelphesFactory *factory = GetFactory();
@@ -192,5 +192,5 @@
 {
   Candidate *candidate;
-  unsigned clusterIndex = 0, maxSeeds = 0;
+  UInt_t clusterIndex = 0, maxSeeds = 0;
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -224,5 +224,5 @@
 ////////////////////////////////////////////////////////////////////////////////
   sort (trackPT.begin (), trackPT.end (), secondDescending);
-  for (vector<pair<unsigned, double> >::const_iterator track = trackPT.begin (); track != trackPT.end (); track++, maxSeeds++)
+  for (vector<pair<UInt_t, Double_t> >::const_iterator track = trackPT.begin (); track != trackPT.end (); track++, maxSeeds++)
     {
       if (track->second < fSeedMinPT)
@@ -242,5 +242,5 @@
 // Create the seeds from the SeedMinPT highest pt tracks.
 ////////////////////////////////////////////////////////////////////////////////
-  for (vector<pair<unsigned, double> >::const_iterator track = trackPT.begin (); track != trackPT.end (); track++, clusterIndex++)
+  for (vector<pair<UInt_t, Double_t> >::const_iterator track = trackPT.begin (); track != trackPT.end (); track++, clusterIndex++)
     {
       addTrackToCluster (track->first, clusterIndex);
@@ -251,11 +251,11 @@
 
 void
-VertexFinder::growCluster (const unsigned clusterIndex)
-{
-  bool done = false;
-  unsigned nearestID;
-  int oldClusterIndex;
-  double nearestDistance;
-  vector<unsigned> nearTracks;
+VertexFinder::growCluster (const UInt_t clusterIndex)
+{
+  Bool_t done = false;
+  UInt_t nearestID;
+  Int_t oldClusterIndex;
+  Double_t nearestDistance;
+  vector<UInt_t> nearTracks;
   nearTracks.clear ();
 
@@ -277,7 +277,7 @@
         {
         
-            for (map<unsigned, map<string, double> >::const_iterator track = trackIDToDouble.begin (); track != trackIDToDouble.end (); track++)
+            for (map<UInt_t, map<string, Double_t> >::const_iterator track = trackIDToDouble.begin (); track != trackIDToDouble.end (); track++)
             {
-              if (trackIDToBool.at (track->first).at ("claimed") || trackIDToInt.at (track->first).at ("clusterIndex") == (int) clusterIndex)
+              if (trackIDToBool.at (track->first).at ("claimed") || trackIDToInt.at (track->first).at ("clusterIndex") == (Int_t) clusterIndex)
                 continue;
                 
@@ -285,6 +285,5 @@
               Double_t sz_vt =  clusterIDToDouble.at (clusterIndex).at ("ez") *  clusterIDToDouble.at (clusterIndex).at ("z");
                 
-              double distance = fabs (clusterIDToDouble.at (clusterIndex).at ("z") - track->second.at ("z")) / hypot (clusterIDToDouble.at (clusterIndex).at ("ez"), track->second.at ("ez"));
-              //double distance = fabs (clusterIDToDouble.at (clusterIndex).at ("z") - track->second.at ("z")) / hypot (sz_vt, sz_tr);
+              Double_t distance = fabs (clusterIDToDouble.at (clusterIndex).at ("z") - track->second.at ("z")) / hypot (clusterIDToDouble.at (clusterIndex).at ("ez"), track->second.at ("ez"));
               if (nearestDistance < 0.0 || distance < nearestDistance)
                 {
@@ -299,9 +298,9 @@
       else
         {
-          for (vector<unsigned>::const_iterator track = nearTracks.begin (); track != nearTracks.end (); track++)
+          for (vector<UInt_t>::const_iterator track = nearTracks.begin (); track != nearTracks.end (); track++)
             {
-              if (trackIDToBool.at (*track).at ("claimed") || trackIDToInt.at (*track).at ("clusterIndex") == (int) clusterIndex)
+              if (trackIDToBool.at (*track).at ("claimed") || trackIDToInt.at (*track).at ("clusterIndex") == (Int_t) clusterIndex)
                 continue;
-              double distance = fabs (clusterIDToDouble.at (clusterIndex).at ("z") - trackIDToDouble.at (*track).at ("z")) / hypot (clusterIDToDouble.at (clusterIndex).at ("ez"), trackIDToDouble.at (*track).at ("ez"));
+              Double_t distance = fabs (clusterIDToDouble.at (clusterIndex).at ("z") - trackIDToDouble.at (*track).at ("z")) / hypot (clusterIDToDouble.at (clusterIndex).at ("ez"), trackIDToDouble.at (*track).at ("ez"));
               if (nearestDistance < 0.0 || distance < nearestDistance)
                 {
@@ -334,6 +333,6 @@
 }
 
-double
-VertexFinder::weight (const unsigned trackID)
+Double_t
+VertexFinder::weight (const UInt_t trackID)
 {
   return ((trackIDToDouble.at (trackID).at ("pt") / (trackIDToDouble.at (trackID).at ("ept") * trackIDToDouble.at (trackID).at ("ez"))) * (trackIDToDouble.at (trackID).at ("pt") / (trackIDToDouble.at (trackID).at ("ept") * trackIDToDouble.at (trackID).at ("ez"))));
@@ -341,7 +340,7 @@
 
 void
-VertexFinder::removeTrackFromCluster (const unsigned trackID, const unsigned clusterID)
-{
-  double wz = weight (trackID);
+VertexFinder::removeTrackFromCluster (const UInt_t trackID, const UInt_t clusterID)
+{
+  Double_t wz = weight (trackID);
 
   trackIDToInt[trackID]["clusterIndex"] = -1;
@@ -357,7 +356,7 @@
 
 void
-VertexFinder::addTrackToCluster (const unsigned trackID, const unsigned clusterID)
-{
-  double wz = weight (trackID);
+VertexFinder::addTrackToCluster (const UInt_t trackID, const UInt_t clusterID)
+{
+  Double_t wz = weight (trackID);
 
   if (!clusterIDToInt.count (clusterID))
Index: modules/VertexFinder.h
===================================================================
--- modules/VertexFinder.h	(revision 641cb3d11465c54796b1c7728ffedad55f2a79fc)
+++ modules/VertexFinder.h	(revision 5658083b2ca17c7982a14446c948b512b30f1608)
@@ -6,7 +6,8 @@
  *  Cluster vertices from tracks
  *
- *  \author M. Selvaggi - UCL, Louvain-la-Neuve
+ *  \authors A. Hart, M. Selvaggi
  *
  */
+
 
 #include "classes/DelphesModule.h"
@@ -36,14 +37,14 @@
   void Finish();
 
-  static bool secondDescending (pair<unsigned, double>, pair<unsigned, double>);
-  static bool secondAscending (pair<unsigned, double>, pair<unsigned, double>);
+  static Bool_t secondDescending (pair<UInt_t, Double_t>, pair<UInt_t, Double_t>);
+  static Bool_t secondAscending (pair<UInt_t, Double_t>, pair<UInt_t, Double_t>);
 
 private:
 
   void createSeeds ();
-  void growCluster (const unsigned);
-  double weight (const unsigned);
-  void addTrackToCluster (const unsigned, const unsigned);
-  void removeTrackFromCluster (const unsigned, const unsigned);
+  void growCluster (const UInt_t);
+  Double_t weight (const UInt_t);
+  void addTrackToCluster (const UInt_t, const UInt_t);
+  void removeTrackFromCluster (const UInt_t, const UInt_t);
 
   Double_t fSigma;
@@ -60,13 +61,13 @@
   TObjArray *fVertexOutputArray;
 
-  map<unsigned, map<string, double> > trackIDToDouble;
-  map<unsigned, map<string, int> > trackIDToInt;
-  map<unsigned, map<string, bool> > trackIDToBool;
+  map<UInt_t, map<string, Double_t> > trackIDToDouble;
+  map<UInt_t, map<string, Int_t> > trackIDToInt;
+  map<UInt_t, map<string, Bool_t> > trackIDToBool;
 
-  map<unsigned, map<string, double> > clusterIDToDouble;
-  map<unsigned, map<string, int> > clusterIDToInt;
-  map<unsigned, map<string, bool> > clusterIDToBool;
-  vector<pair<unsigned, double> > trackPT;
-  vector<pair<unsigned, double> > clusterSumPT2;
+  map<UInt_t, map<string, Double_t> > clusterIDToDouble;
+  map<UInt_t, map<string, Int_t> > clusterIDToInt;
+  map<UInt_t, map<string, Bool_t> > clusterIDToBool;
+  vector<pair<UInt_t, Double_t> > trackPT;
+  vector<pair<UInt_t, Double_t> > clusterSumPT2;
 
   ClassDef(VertexFinder, 1)
Index: modules/VertexSorter.cc
===================================================================
--- modules/VertexSorter.cc	(revision 641cb3d11465c54796b1c7728ffedad55f2a79fc)
+++ modules/VertexSorter.cc	(revision 5658083b2ca17c7982a14446c948b512b30f1608)
@@ -1,20 +1,14 @@
 /** \class VertexSorter
  *
- *  Merges particles from pile-up sample into event
- *
- *
- *  $Date: 2013-02-12 15:13:59 +0100 (Tue, 12 Feb 2013) $
- *  $Revision: 907 $
- *
- *
- *  \author M. Selvaggi - UCL, Louvain-la-Neuve
- *
- */
+ *
+ *  Sorts vertices according to different criteria
+ *
+ *  \authors A. Hart, M. Selvaggi
+ *
+ *
+*/
 
 #include <unordered_map>
 #include "modules/VertexSorter.h"
-
-//#include "CLHEP/Units/GlobalSystemOfUnits.h"
-//#include "CLHEP/Units/GlobalPhysicalConstants.h"
 
 #include "classes/DelphesClasses.h"
@@ -37,9 +31,9 @@
 #include "TVector3.h"
 
-static const double mm  = 1.;
-static const double m = 1000.*mm;
-static const double ns  = 1.;
-static const double s = 1.e+9 *ns;
-static const double c_light   = 2.99792458e+8 * m/s;
+static const Double_t mm  = 1.;
+static const Double_t m = 1000.*mm;
+static const Double_t ns  = 1.;
+static const Double_t s = 1.e+9 *ns;
+static const Double_t c_light   = 2.99792458e+8 * m/s;
 
 //------------------------------------------------------------------------------
@@ -96,9 +90,9 @@
 //------------------------------------------------------------------------------
 //
-bool VertexSorter::secondDescending (pair<unsigned, double> pair0, pair<unsigned, double> pair1)
+Bool_t VertexSorter::secondDescending (pair<UInt_t, Double_t> pair0, pair<UInt_t, Double_t> pair1)
 {
   return (pair0.second > pair1.second);
 }
-bool VertexSorter::secondAscending (pair<unsigned, double> pair0, pair<unsigned, double> pair1)
+Bool_t VertexSorter::secondAscending (pair<UInt_t, Double_t> pair0, pair<UInt_t, Double_t> pair1)
 {
   return (pair0.second < pair1.second);
@@ -108,9 +102,9 @@
 {
   Candidate *candidate, *jetCandidate, *beamSpotCandidate;
-  unordered_map<int, unsigned> clusterIDToIndex;
-  unordered_map<int, double> clusterIDToSumPT2;
-  vector<pair<int, double> > sortedClusterIDs;
-
-  for (int iCluster = 0; iCluster < fInputArray->GetEntries (); iCluster++)
+  unordered_map<Int_t, UInt_t> clusterIDToIndex;
+  unordered_map<Int_t, Double_t> clusterIDToSumPT2;
+  vector<pair<Int_t, Double_t> > sortedClusterIDs;
+
+  for (Int_t iCluster = 0; iCluster < fInputArray->GetEntries (); iCluster++)
     {
       const Candidate &cluster = *((Candidate *) fInputArray->At (iCluster));
@@ -135,5 +129,5 @@
             continue;
           TLorentzVector p (candidate->Momentum.Px (), candidate->Momentum.Py (), candidate->Momentum.Pz (), candidate->Momentum.E ());
-          bool isInJet = false;
+          Bool_t isInJet = false;
 
           fItJetInputArray->Reset();
@@ -173,5 +167,5 @@
 
       beamSpotCandidate = (Candidate *) fBeamSpotInputArray->At (0);
-      for (int iCluster = 0; iCluster < fInputArray->GetEntries (); iCluster++)
+      for (Int_t iCluster = 0; iCluster < fInputArray->GetEntries (); iCluster++)
         {
           const Candidate &cluster = *((Candidate *) fInputArray->At (iCluster));
Index: modules/VertexSorter.h
===================================================================
--- modules/VertexSorter.h	(revision 641cb3d11465c54796b1c7728ffedad55f2a79fc)
+++ modules/VertexSorter.h	(revision 5658083b2ca17c7982a14446c948b512b30f1608)
@@ -4,14 +4,11 @@
 /** \class VertexSorter
  *
- *  Merges particles from pile-up sample into event
+ *
+ *  Sorts vertices according to different criteria
+ *
+ *  \authors A. Hart, M. Selvaggi
  *
  *
- *  $Date: 2013-02-12 15:13:59 +0100 (Tue, 12 Feb 2013) $
- *  $Revision: 907 $
- *
- *
- *  \author M. Selvaggi - UCL, Louvain-la-Neuve
- *
- */
+*/
 
 #include "classes/DelphesModule.h"
@@ -42,6 +39,6 @@
   void Finish();
 
-  static bool secondDescending (pair<unsigned, double>, pair<unsigned, double>);
-  static bool secondAscending (pair<unsigned, double>, pair<unsigned, double>);
+  static Bool_t secondDescending (pair<UInt_t, Double_t>, pair<UInt_t, Double_t>);
+  static Bool_t secondAscending (pair<UInt_t, Double_t>, pair<UInt_t, Double_t>);
 
 private: